## mingw-w64-freecad-1.0.2-1.src.tar.zst

=== OndselSolver/CMakeLists.txt ===
if ( ONDSELSOLVER_BUILD_SHARED )
    message( STATUS "[OndselSolver] Building shared library" )
    add_library(OndselSolver SHARED)
else()
    message( STATUS "[OndselSolver] Building static library" )
    add_library(OndselSolver STATIC)
endif()

set(ONDSELSOLVER_SRC
        Abs.cpp
        AbsConstraint.cpp
        AccICKineNewtonRaphson.cpp
        AccICNewtonRaphson.cpp
        AccKineNewtonRaphson.cpp
        AccNewtonRaphson.cpp
        AllowZRotation.cpp
        AllowZRotationConstraintIqctJqc.cpp
        AngleJoint.cpp
        AngleZConstraintIJ.cpp
        AngleZConstraintIqcJc.cpp
        AngleZConstraintIqcJqc.cpp
        AngleZIecJec.cpp
        AngleZIeqcJec.cpp
        AngleZIeqcJeqc.cpp
        AnyGeneralSpline.cpp
        AnyPosICNewtonRaphson.cpp
        ArcSine.cpp
        ArcTan.cpp
        ArcTan2.cpp
        Arguments.cpp
        Array.cpp
        ASMTAllowRotation.cpp
        ASMTAngleJoint.cpp
        ASMTAnimationParameters.cpp
        ASMTAssembly.cpp
        ASMTConeConeContact.cpp
        ASMTContact.cpp
        ASMTCylConeContact.cpp
        ASMTCylCylContact.cpp
        ASMTCompoundJoint.cpp
        ASMTConstantGravity.cpp
        ASMTConstantVelocityJoint.cpp
        ASMTConstraintSet.cpp
        ASMTCylindricalJoint.cpp
        ASMTCylSphJoint.cpp
        ASMTExtrusion.cpp
        ASMTFixedJoint.cpp
        ASMTForceTorque.cpp
        ASMTGearJoint.cpp
        ASMTGeneralMotion.cpp
        ASMTInPlaneJoint.cpp
        ASMTItem.cpp
        ASMTItemIJ.cpp
        ASMTJoint.cpp
        ASMTKinematicIJ.cpp
        ASMTLimit.cpp
        ASMTLineInPlaneJoint.cpp
        ASMTMarker.cpp
        ASMTMotion.cpp
        ASMTNoRotationJoint.cpp
        ASMTParallelAxesJoint.cpp
        ASMTPart.cpp
        ASMTPerpendicularJoint.cpp
        ASMTPlanarJoint.cpp
        ASMTPointInLineJoint.cpp
        ASMTPointInPlaneJoint.cpp
        ASMTPrincipalMassMarker.cpp
        ASMTRackPinionJoint.cpp
        ASMTRefCurve.cpp
        ASMTRefItem.cpp
        ASMTRefPoint.cpp
        ASMTRefSurface.cpp
        ASMTRevCylJoint.cpp
        ASMTRevoluteJoint.cpp
        ASMTRevRevJoint.cpp
        ASMTRotationalMotion.cpp
        ASMTRotationLimit.cpp
        ASMTScrewJoint.cpp
        ASMTSimulationParameters.cpp
        ASMTSpatialContainer.cpp
        ASMTSpatialItem.cpp
        ASMTSphericalJoint.cpp
        ASMTSphSphJoint.cpp
        ASMTTime.cpp
        ASMTTranslationalJoint.cpp
        ASMTTranslationalMotion.cpp
        ASMTTranslationLimit.cpp
        ASMTUniversalJoint.cpp
        AtPointConstraintIJ.cpp
        AtPointConstraintIqcJc.cpp
        AtPointConstraintIqcJqc.cpp
        AtPointConstraintIqctJqc.cpp
        AtPointJoint.cpp
        BasicIntegrator.cpp
        BasicQuasiIntegrator.cpp
        BasicUserFunction.cpp
        CADSystem.cpp
        CartesianFrame.cpp
        CompoundJoint.cpp
        Constant.cpp
        ConstantGravity.cpp
        ConstantVelocityJoint.cpp
        Constraint.cpp
        ConstraintIJ.cpp
        ConstraintSet.cpp
        ConstVelConstraintIJ.cpp
        ConstVelConstraintIqcJc.cpp
        ConstVelConstraintIqcJqc.cpp
        Cosine.cpp
        CREATE.cpp
        CylindricalJoint.cpp
        CylSphJoint.cpp
        DiagonalMatrix.cpp
        DifferenceOperator.cpp
        DifferentiatedGeneralSpline.cpp
        DirectionCosineConstraintIJ.cpp
        DirectionCosineConstraintIqcJc.cpp
        DirectionCosineConstraintIqcJqc.cpp
        DirectionCosineConstraintIqctJqc.cpp
        DirectionCosineIecJec.cpp
        DirectionCosineIeqcJec.cpp
        DirectionCosineIeqcJeqc.cpp
        DirectionCosineIeqctJeqc.cpp
        DiscontinuityError.cpp
        DispCompIecJecIe.cpp
        DispCompIecJecKec.cpp
        DispCompIecJecKeqc.cpp
        DispCompIecJecO.cpp
        DispCompIeqcJecIe.cpp
        DispCompIeqcJecKeqc.cpp
        DispCompIeqcJecO.cpp
        DispCompIeqcJeqcIe.cpp
        DispCompIeqcJeqcKeqc.cpp
        DispCompIeqcJeqcKeqct.cpp
        DispCompIeqcJeqcO.cpp
        DispCompIeqctJeqcIe.cpp
        DispCompIeqctJeqcKeqct.cpp
        DispCompIeqctJeqcO.cpp
        DistanceConstraintIJ.cpp
        DistanceConstraintIqcJc.cpp
        DistanceConstraintIqcJqc.cpp
        DistanceConstraintIqctJqc.cpp
        DistancexyConstraintIJ.cpp
        DistancexyConstraintIqcJc.cpp
        DistancexyConstraintIqcJqc.cpp
        DistIecJec.cpp
        DistIeqcJec.cpp
        DistIeqcJeqc.cpp
        DistIeqctJeqc.cpp
        DistxyIecJec.cpp
        DistxyIeqcJec.cpp
        DistxyIeqcJeqc.cpp
        DistxyIeqctJeqc.cpp
        EigenDecomposition.cpp
        EndFramec.cpp
        EndFrameqc.cpp
        EndFrameqct.cpp
        EndFrameqct2.cpp
        EulerAngles.cpp
        EulerAnglesDDot.cpp
        EulerAnglesDot.cpp
        EulerAngleszxz.cpp
        EulerAngleszxzDDot.cpp
        EulerAngleszxzDot.cpp
        EulerArray.cpp
        EulerConstraint.cpp
        EulerParameters.cpp
        EulerParametersDDot.cpp
        EulerParametersDot.cpp
        Exponential.cpp
        ExpressionX.cpp
        ExternalSystem.cpp
        FixedJoint.cpp
        ForceTorqueData.cpp
        ForceTorqueItem.cpp
        FullColumn.cpp
        FullMatrix.cpp
        FullMotion.cpp
        FullRow.cpp
        FullVector.cpp
        Function.cpp
        FunctionFromData.cpp
        FunctionWithManyArgs.cpp
        FunctionX.cpp
        FunctionXcParameter.cpp
        FunctionXY.cpp
        GearConstraintIJ.cpp
        GearConstraintIqcJc.cpp
        GearConstraintIqcJqc.cpp
        GearJoint.cpp
        GEFullMat.cpp
        GEFullMatFullPv.cpp
        GEFullMatParPv.cpp
        GeneralSpline.cpp
        GESpMat.cpp
        GESpMatFullPv.cpp
        GESpMatFullPvPosIC.cpp
        GESpMatParPv.cpp
        GESpMatParPvMarko.cpp
        GESpMatParPvMarkoFast.cpp
        GESpMatParPvPrecise.cpp
        ICKineIntegrator.cpp
        IndependentVariable.cpp
        InLineJoint.cpp
        InPlaneJoint.cpp
        Integral.cpp
        Integrator.cpp
        IntegratorInterface.cpp
        Item.cpp
        ItemIJ.cpp
        Joint.cpp
        KineIntegrator.cpp
        KinematicIeJe.cpp
        LDUFullMat.cpp
        LDUFullMatParPv.cpp
        LDUSpMat.cpp
        LDUSpMatParPv.cpp
        LDUSpMatParPvMarko.cpp
        LDUSpMatParPvPrecise.cpp
        LimitIJ.cpp
        LinearMultiStepMethod.cpp
        LineInPlaneJoint.cpp
        Ln.cpp
        Log10.cpp
        LogN.cpp
        MarkerFrame.cpp
        MatrixDecomposition.cpp
        MatrixGaussElimination.cpp
        MatrixLDU.cpp
        MatrixSolver.cpp
        MaximumIterationError.cpp
        MbDMath.cpp
        MomentOfInertiaSolver.cpp
        Negative.cpp
        NewtonRaphson.cpp
        NewtonRaphsonError.cpp
        NoRotationJoint.cpp
        NotKinematicError.cpp
        Numeric.cpp
        OrbitAngleZIecJec.cpp
        OrbitAngleZIeqcJec.cpp
        OrbitAngleZIeqcJeqc.cpp
        Orientation.cpp
        ParallelAxesJoint.cpp
        Part.cpp
        PartFrame.cpp
        PerpendicularJoint.cpp
        PiecewiseFunction.cpp
        PlanarJoint.cpp
        PointInLineJoint.cpp
        PointInPlaneJoint.cpp
        Polynomial.cpp
        PosICDragLimitNewtonRaphson.cpp
        PosICDragNewtonRaphson.cpp
        PosICKineNewtonRaphson.cpp
        PosICNewtonRaphson.cpp
        PosKineNewtonRaphson.cpp
        PosNewtonRaphson.cpp
        PosVelAccData.cpp
        Power.cpp
        PrescribedMotion.cpp
        Product.cpp
        QuasiIntegrator.cpp
        RackPinConstraintIJ.cpp
        RackPinConstraintIqcJc.cpp
        RackPinConstraintIqcJqc.cpp
        RackPinJoint.cpp
        RampStepFunction.cpp
        Reciprocal.cpp
        RedundantConstraint.cpp
        RevCylJoint.cpp
        RevoluteJoint.cpp
        RevRevJoint.cpp
        RotationLimitIJ.cpp
        RowTypeMatrix.cpp
        ScalarNewtonRaphson.cpp
        ScrewConstraintIJ.cpp
        ScrewConstraintIqcJc.cpp
        ScrewConstraintIqcJqc.cpp
        ScrewJoint.cpp
        SimulationStoppingError.cpp
        Sine.cpp
        SingularMatrixError.cpp
        Solver.cpp
        SparseColumn.cpp
        SparseMatrix.cpp
        SparseRow.cpp
        SparseVector.cpp
        SphericalJoint.cpp
        SphSphJoint.cpp
        StableBackwardDifference.cpp
        StateData.cpp
        Sum.cpp
        Symbolic.cpp
        SymbolicParser.cpp
        SyntaxError.cpp
        System.cpp
        SystemNewtonRaphson.cpp
        SystemSolver.cpp
        SymTime.cpp
        TooManyTriesError.cpp
        TooSmallStepSizeError.cpp
        Translation.cpp
        TranslationalJoint.cpp
        TranslationConstraintIJ.cpp
        TranslationConstraintIqcJc.cpp
        TranslationConstraintIqcJqc.cpp
        TranslationConstraintIqctJqc.cpp
        TranslationLimitIJ.cpp
        Units.cpp
        UniversalJoint.cpp
        UserFunction.cpp
        Variable.cpp
        VectorNewtonRaphson.cpp
        VelICKineSolver.cpp
        VelICSolver.cpp
        VelKineSolver.cpp
        VelSolver.cpp
        ZRotation.cpp
        ZTranslation.cpp
)

set(ONDSELSOLVER_HEADERS
        Abs.h
        AbsConstraint.h
        AccICKineNewtonRaphson.h
        AccICNewtonRaphson.h
        AccKineNewtonRaphson.h
        AccNewtonRaphson.h
        AllowZRotation.h
        AllowZRotationConstraintIqctJqc.h
        AngleJoint.h
        AngleZConstraintIJ.h
        AngleZConstraintIqcJc.h
        AngleZConstraintIqcJqc.h
        AngleZIecJec.h
        AngleZIeqcJec.h
        AngleZIeqcJeqc.h
        AnyGeneralSpline.h
        AnyPosICNewtonRaphson.h
        ArcSine.h
        ArcTan.h
        ArcTan2.h
        Arguments.h
        Array.h
        ASMTAllowRotation.h
        ASMTAngleJoint.h
        ASMTAnimationParameters.h
        ASMTAssembly.h
        ASMTAtPointJoint.h
        ASMTCompoundJoint.h
        ASMTConstantGravity.h
        ASMTConstantVelocityJoint.h
        ASMTConstraintSet.h
        ASMTCylindricalJoint.h
        ASMTCylSphJoint.h
        ASMTExtrusion.h
        ASMTFixedJoint.h
        ASMTForceTorque.h
        ASMTGearJoint.h
        ASMTGeneralMotion.h
        ASMTInLineJoint.h
        ASMTInPlaneJoint.h
        ASMTItem.h
        ASMTItemIJ.h
        ASMTJoint.h
        ASMTKinematicIJ.h
        ASMTLimit.h
        ASMTLineInPlaneJoint.h
        ASMTMarker.h
        ASMTMotion.h
        ASMTNoRotationJoint.h
        ASMTParallelAxesJoint.h
        ASMTPart.h
        ASMTPerpendicularJoint.h
        ASMTPlanarJoint.h
        ASMTPointInLineJoint.h
        ASMTPointInPlaneJoint.h
        ASMTPrincipalMassMarker.h
        ASMTRackPinionJoint.h
        ASMTRefCurve.h
        ASMTRefItem.h
        ASMTRefPoint.h
        ASMTRefSurface.h
        ASMTRevCylJoint.h
        ASMTRevoluteJoint.h
        ASMTRevRevJoint.h
        ASMTRotationalMotion.h
        ASMTRotationLimit.h
        ASMTScrewJoint.h
        ASMTSimulationParameters.h
        ASMTSpatialContainer.h
        ASMTSpatialItem.h
        ASMTSphericalJoint.h
        ASMTSphSphJoint.h
        ASMTTime.h
        ASMTTranslationalJoint.h
        ASMTTranslationalMotion.h
        ASMTTranslationLimit.h
        ASMTUniversalJoint.h
        AtPointConstraintIJ.h
        AtPointConstraintIqcJc.h
        AtPointConstraintIqcJqc.h
        AtPointConstraintIqctJqc.h
        AtPointJoint.h
        BasicIntegrator.h
        BasicQuasiIntegrator.h
        BasicUserFunction.h
        CADSystem.h
        CartesianFrame.h
        CompoundJoint.h
        ASMTConeConeContact.h
        ASMTContact.h
        ASMTCylConeContact.h
        ASMTCylCylContact.h
        Constant.h
        ConstantGravity.h
        ConstantVelocityJoint.h
        Constraint.h
        ConstraintIJ.h
        ConstraintSet.h
        ConstVelConstraintIJ.h
        ConstVelConstraintIqcJc.h
        ConstVelConstraintIqcJqc.h
        Cosine.h
        CREATE.h
        CylindricalJoint.h
        CylSphJoint.h
        DiagonalMatrix.h
        DifferenceOperator.h
        DifferentiatedGeneralSpline.h

=== src/Base/CMakeLists.txt ===
if(WIN32)
    add_definitions(-DFCBase)
    add_definitions(-DPYCXX_DLL)
    add_definitions(-DBOOST_DYN_LINK)
    add_definitions(-DZIPIOS_UTF8)
endif(WIN32)

include_directories(
    ${CMAKE_BINARY_DIR}/src
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
)

include_directories(
    SYSTEM
    ${Boost_INCLUDE_DIRS}
    ${PYTHON_INCLUDE_DIRS}
    ${XercesC_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIR}
    ${PYCXX_INCLUDE_DIR}
)

if(MSVC)
    set(FreeCADBase_LIBS
        ${Boost_LIBRARIES}
        ${XercesC_LIBRARIES}
        ${ZLIB_LIBRARIES}
        debug MSVCRTD.LIB
        debug MSVCPRTD.LIB
        optimized MSVCRT.LIB
        optimized MSVCPRT.LIB
        Rpcrt4.lib
        version.lib
    )

    #Universal C runtime introduced in VS 2015 (cl version 19)
    if (NOT (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "19"))
        list(APPEND FreeCADBase_LIBS
            debug vcruntimed.lib
            debug ucrtd.lib
            debug concrtd.lib
            optimized vcruntime.lib
            optimized ucrt.lib
            optimized concrt.lib
        )
    endif()
elseif(MINGW)
    set(FreeCADBase_LIBS
        ${XercesC_LIBRARIES}
        ${Boost_LIBRARIES}
        ${ZLIB_LIBRARIES}
        Rpcrt4.lib
    )
else(MSVC)
    set(FreeCADBase_LIBS
        ${XercesC_LIBRARIES}
        ${Boost_LIBRARIES}
        ${ZLIB_LIBRARIES}
    )
endif(MSVC)

include_directories(
    ${QtCore_INCLUDE_DIRS}
)
list(APPEND FreeCADBase_LIBS ${QtCore_LIBRARIES})

list(APPEND FreeCADBase_LIBS fmt::fmt)

if (BUILD_DYNAMIC_LINK_PYTHON)
    list(APPEND FreeCADBase_LIBS ${PYTHON_LIBRARIES})
endif (BUILD_DYNAMIC_LINK_PYTHON)

# needed for OpenSUSE
if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    list(APPEND FreeCADBase_LIBS -lutil -ldl)
endif()

generate_from_xml(TypePy)
generate_from_xml(BaseClassPy)
generate_from_xml(BoundBoxPy)
generate_from_xml(CoordinateSystemPy)
generate_from_xml(PersistencePy)
generate_from_xml(VectorPy)
generate_from_xml(MatrixPy)
generate_from_xml(RotationPy)
generate_from_xml(PlacementPy)
generate_from_xml(AxisPy)
generate_from_xml(UnitPy)
generate_from_xml(QuantityPy)
generate_from_xml(PrecisionPy)
generate_from_any(Parameter.xsd Parameter.inl xmlSchemeString)

if(SWIG_FOUND)
    # Create the file swigpyrun.hh and then compare with the file swigpyrun.h.
    # If the files are different or if swigpyrun.h doesn't exist then copy swigpyrun.hh.
    # This is to avoid to having to build the target each time cmake configure is executed.
    execute_process(COMMAND ${SWIG_EXECUTABLE} -python -external-runtime ${CMAKE_CURRENT_BINARY_DIR}/swigpyrun.hh)

    fc_copy_file_if_different(
        "${CMAKE_CURRENT_BINARY_DIR}/swigpyrun.hh"
        "${CMAKE_CURRENT_BINARY_DIR}/swigpyrun.h"
    )
    add_definitions(-DHAVE_SWIG=1)
endif(SWIG_FOUND)

if (EXISTS ${CMAKE_SOURCE_DIR}/src/zipios++ AND NOT FREECAD_USE_EXTERNAL_ZIPIOS)
SET(zipios_SRCS
    ../zipios++/backbuffer.h
    ../zipios++/collcoll.cpp
    ../zipios++/collcoll.h
    ../zipios++/deflateoutputstreambuf.cpp
    ../zipios++/deflateoutputstreambuf.h
    ../zipios++/fcoll.cpp
    ../zipios++/fcoll.h
    ../zipios++/fcollexceptions.cpp
    ../zipios++/fcollexceptions.h
    ../zipios++/fileentry.cpp
    ../zipios++/fileentry.h
    ../zipios++/filepath.cpp
    ../zipios++/filepath.h
    ../zipios++/filterinputstreambuf.cpp
    ../zipios++/filterinputstreambuf.h
    ../zipios++/filteroutputstreambuf.cpp
    ../zipios++/filteroutputstreambuf.h
    ../zipios++/gzipoutputstream.cpp
    ../zipios++/gzipoutputstream.h
    ../zipios++/gzipoutputstreambuf.cpp
    ../zipios++/gzipoutputstreambuf.h
    ../zipios++/inflateinputstreambuf.cpp
    ../zipios++/inflateinputstreambuf.h
    ../zipios++/meta-iostreams.h
    ../zipios++/outputstringstream.h
    ../zipios++/simplesmartptr.h
    ../zipios++/virtualseeker.h
    ../zipios++/zipfile.cpp
    ../zipios++/zipfile.h
    ../zipios++/ziphead.cpp
    ../zipios++/ziphead.h
    ../zipios++/zipheadio.cpp
    ../zipios++/zipheadio.h
    ../zipios++/zipinputstream.cpp
    ../zipios++/zipinputstream.h
    ../zipios++/zipinputstreambuf.cpp
    ../zipios++/zipinputstreambuf.h
    ../zipios++/zipios_common.h
    ../zipios++/zipios-config.h
    ../zipios++/zipios_defs.h
    ../zipios++/zipoutputstreambuf.cpp
    ../zipios++/zipoutputstreambuf.h
    ../zipios++/zipoutputstream.cpp
    ../zipios++/zipoutputstream.h
)
SOURCE_GROUP("zipios" FILES ${zipios_SRCS})
endif ()

SOURCE_GROUP("pycxx" FILES ${PYCXX_SOURCES})

# auto-generate resource file with all available translations
set (FreeCADBase_TR_QRC ${CMAKE_CURRENT_BINARY_DIR}/Resources/Base_translation.qrc)
qt_find_and_add_translation(QM_SRCS "Resources/translations/*_*.ts"
    ${CMAKE_CURRENT_BINARY_DIR}/Resources/translations)
qt_create_resource_file(${FreeCADBase_TR_QRC} ${QM_SRCS})
qt_add_resources(FreeCADBase_QRC_SRCS ${FreeCADBase_TR_QRC})

SET(FreeCADBase_XML_SRCS
    AxisPy.xml
    BaseClassPy.xml
    BoundBoxPy.xml
    CoordinateSystemPy.xml
    MatrixPy.xml
    PersistencePy.xml
    PlacementPy.xml
    RotationPy.xml
    VectorPy.xml
    QuantityPy.xml
    TypePy.xml
    UnitPy.xml
    PrecisionPy.xml
)
SOURCE_GROUP("XML" FILES ${FreeCADBase_XML_SRCS})

SET(FreeCADBase_UNITAPI_SRCS
    UnitsApi.cpp
    UnitsApiPy.cpp
    UnitsApi.h
    UnitsSchema.h
    UnitsSchema.cpp
    UnitsSchemaInternal.h
    UnitsSchemaInternal.cpp
    UnitsSchemaMKS.h
    UnitsSchemaMKS.cpp
    UnitsSchemaImperial1.h
    UnitsSchemaImperial1.cpp
    UnitsSchemaCentimeters.h
    UnitsSchemaCentimeters.cpp
    UnitsSchemaMmMin.h
    UnitsSchemaMmMin.cpp
    UnitsSchemaFemMilliMeterNewton.h
    UnitsSchemaFemMilliMeterNewton.cpp
    UnitsSchemaMeterDecimal.h
    UnitsSchemaMeterDecimal.cpp
    Quantity.h
    Quantity.cpp
    QuantityPyImp.cpp
    QuantityParser.l
    QuantityParser.y
    Unit.h
    Unit.cpp
    UnitPyImp.cpp
)
SOURCE_GROUP("Units" FILES ${FreeCADBase_UNITAPI_SRCS})

SET(SWIG_SRCS
    swigpyrun.cpp
)

SET(FreeCADBase_CPP_SRCS
    Axis.cpp
    AxisPyImp.cpp
    Base64.cpp
    BaseClass.cpp
    BaseClassPyImp.cpp
    BindingManager.cpp
    BoundBoxPyImp.cpp
    Builder3D.cpp
    Console.cpp
    ConsoleObserver.cpp
    CoordinateSystem.cpp
    CoordinateSystemPyImp.cpp
    Debugger.cpp
    DualQuaternion.cpp
    Exception.cpp
    ExceptionFactory.cpp
    Factory.cpp
    FileInfo.cpp
    FileTemplate.cpp
    FutureWatcherProgress.cpp
    GeometryPyCXX.cpp
    Handle.cpp
    InputSource.cpp
    Interpreter.cpp
    Matrix.cpp
    MatrixPyImp.cpp
    Observer.cpp
    Parameter.xsd
    Parameter.cpp
    ParameterPy.cpp
    Persistence.cpp
    PersistencePyImp.cpp
    Placement.cpp
    PlacementPyImp.cpp
    PrecisionPyImp.cpp
    ProgressIndicatorPy.cpp
    PyExport.cpp
    PyObjectBase.cpp
    PythonTypeExt.cpp
    QtTools.cpp
    Reader.cpp
    Rotation.cpp
    RotationPyImp.cpp
    Sequencer.cpp
    SmartPtrPy.cpp
    Stream.cpp
    Swap.cpp
    ${SWIG_SRCS}
    Tools.cpp
    Tools2D.cpp
    Tools3D.cpp
    Translate.cpp
    Type.cpp
    TypePyImp.cpp
    Uuid.cpp
    Vector3D.cpp
    VectorPyImp.cpp
    ViewProj.cpp
    Writer.cpp
    XMLTools.cpp
    ZipHeader.cpp
)

SET(SWIG_HEADERS
    swigpyrun.inl
)

SET(FreeCADBase_HPP_SRCS
    Axis.h
    Base64.h
    Base64Filter.h
    BaseClass.h
    BindingManager.h
    Bitmask.h
    BoundBox.h
    Builder3D.h
    Console.h
    ConsoleObserver.h
    Converter.h
    CoordinateSystem.h
    Debugger.h
    DualNumber.h
    DualQuaternion.h
    Exception.h
    ExceptionFactory.h
    Factory.h
    FileInfo.h
    FileTemplate.h
    FutureWatcherProgress.h
    GeometryPyCXX.h
    Handle.h
    InputSource.h
    Interpreter.h
    Matrix.h
    Observer.h
    Parameter.h
    Persistence.h
    Placement.h
    Precision.h
    ProgressIndicatorPy.h
    PyExport.h
    PyObjectBase.h
    PyWrapParseTupleAndKeywords.h
    PythonTypeExt.h
    QtTools.h
    Reader.h
    Rotation.h
    Sequencer.h
    SmartPtrPy.h
    Stream.h
    Swap.h
    ${SWIG_HEADERS}
    TimeInfo.h
    Tools.h
    Tools2D.h
    Tools3D.h
    Translate.h
    Type.h
    Uuid.h
    Vector3D.h
    ViewProj.h
    Writer.h
    XMLTools.h
    ZipHeader.h
)

SET(FreeCADBase_SRCS
    ${PYCXX_SOURCES}
    ${FreeCADBase_QRC_SRCS}
    ${FreeCADBase_CPP_SRCS}
    ${FreeCADBase_HPP_SRCS}
    ${FreeCADBase_XML_SRCS}
    ${FreeCADBase_UNITAPI_SRCS}
    PyTools.c
    PyTools.h
    PreCompiled.cpp
    PreCompiled.h
)

IF (MSVC)
    SET(FreeCADBase_SRCS
        ${FreeCADBase_SRCS}
        StackWalker.cpp
        StackWalker.h
)
ENDIF(MSVC)

# Use external zipios++ if specified.
if(FREECAD_USE_EXTERNAL_ZIPIOS)
    find_library(ZIPIOS_LIBRARY zipios)
    find_path(ZIPIOS_INCLUDES zipios++/zipios-config.h)
    if(ZIPIOS_LIBRARY)
        message(STATUS "Found zipios++: ${ZIPIOS}")
    endif()
    if(ZIPIOS_INCLUDES)
        message(STATUS "Found zipios++ headers.")
    endif()
    if(ZIPIOS_LIBRARY AND ZIPIOS_INCLUDES)
        list(APPEND FreeCADBase_LIBS ${ZIPIOS_LIBRARY})
        include_directories(${ZIPIOS_INCLUDES})
    else()
        message(FATAL_ERROR "Using external zipios++ was specified but was not found.")
    endif()
else(FREECAD_USE_EXTERNAL_ZIPIOS)
    list(APPEND FreeCADBase_SRCS ${zipios_SRCS})
endif(FREECAD_USE_EXTERNAL_ZIPIOS)


if(FREECAD_USE_PCH)
    add_definitions(-D_PreComp_)
    ADD_MSVC_PRECOMPILED_HEADER(FreeCADBase PreCompiled.h PreCompiled.cpp FreeCADBase_CPP_SRCS)
endif(FREECAD_USE_PCH)

add_library(FreeCADBase SHARED ${FreeCADBase_SRCS})

target_link_libraries(FreeCADBase ${FreeCADBase_LIBS})
if (FREECAD_WARN_ERROR)
    target_compile_warn_error(FreeCADBase)
endif()

SET_BIN_DIR(FreeCADBase FreeCADBase)

if(WIN32)
    INSTALL(TARGETS FreeCADBase
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
else(WIN32)
    INSTALL(TARGETS FreeCADBase
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
endif(WIN32)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=freecad
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=1.0.2
pkgrel=1
_OS_commit=09d6175a
pkgdesc="Free and Opensource multiplatform 3D parametric modeler (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://freecadweb.org/'
msys2_repository_url="https://github.com/FreeCAD/FreeCAD"
msys2_references=(
  'archlinux: freecad'
)
license=('spdx:GPL-2.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-boost-libs"
         "${MINGW_PACKAGE_PREFIX}-coin"
         "${MINGW_PACKAGE_PREFIX}-fmt"
         "${MINGW_PACKAGE_PREFIX}-freetype"
         "${MINGW_PACKAGE_PREFIX}-med"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-opencascade"
         "${MINGW_PACKAGE_PREFIX}-openscad"
         "${MINGW_PACKAGE_PREFIX}-python"
         "${MINGW_PACKAGE_PREFIX}-python-numpy"
         "${MINGW_PACKAGE_PREFIX}-python-packaging"
         "${MINGW_PACKAGE_PREFIX}-python-pivy"
         "${MINGW_PACKAGE_PREFIX}-pyside6"
         "${MINGW_PACKAGE_PREFIX}-qt6-base"
         "${MINGW_PACKAGE_PREFIX}-qt6-svg"
         "${MINGW_PACKAGE_PREFIX}-xerces-c"
         "${MINGW_PACKAGE_PREFIX}-vtk"
         "${MINGW_PACKAGE_PREFIX}-yaml-cpp"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-nlohmann-json"
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-python-matplotlib"
             "${MINGW_PACKAGE_PREFIX}-qt6-tools"
             "${MINGW_PACKAGE_PREFIX}-swig"
             "${MINGW_PACKAGE_PREFIX}-fast_float"
             "${MINGW_PACKAGE_PREFIX}-microsoft-gsl"
             "${MINGW_PACKAGE_PREFIX}-utf8cpp")
source=("https://github.com/FreeCAD/FreeCAD/archive/${pkgver}/${_realname}-${pkgver}.tar.gz"
        "https://github.com/Ondsel-Development/OndselSolver/archive/${_OS_commit}/OndselSolver-${_OS_commit}.tar.gz"
        "001-clang19-char-traits.patch")
sha256sums=('228ee52f00627c7d8fa61998179deb01865ece69390829feb1300228d24f7e9e'
            '890fb6ddeb1b42face95854689ff7b96c926c368b7d616d9e31e4b35f79ddde8'
            '0dcc9a5ce20f080913f2bff71f5e2eb7d166e789f1012cea2009f94c9f30e5f2')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Nbp1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  mv OndselSolver-*/* FreeCAD-${pkgver}/src/3rdParty/OndselSolver/

  cd FreeCAD-${pkgver}

  apply_patch_with_msg \
    001-clang19-char-traits.patch
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${CC} == clang ]]; then
    CXXFLAGS+=" -Wno-macro-redefined"
  else
    CXXFLAGS+=" -Wno-template-id-cdtor"
  fi

  CXXFLAGS+=" -Wno-deprecated-declarations -Wno-unknown-pragmas" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=;" \
    cmake -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DFREECAD_QT_VERSION="6" \
      -DBUILD_TEST=OFF \
      -DBUILD_WEB=OFF \
      -DBUILD_ADDONMGR=OFF \
      -DENABLE_DEVELOPER_TESTS=OFF \
      -DINSTALL_TO_SITEPACKAGES=OFF \
      -DPython_EXECUTABLE=${MINGW_PREFIX}/bin/python \
      -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python \
      "${_extra_config[@]}" \
      -S "FreeCAD-${pkgver}" \
      -B "build-${MSYSTEM}"

  cmake --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"

  install -Dm644 FreeCAD-${pkgver}/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE

  MSYS2_ARG_CONV_EXCL="-d" \
    python -m compileall -o 0 -o 1 -q -d"${MINGW_PREFIX}" "${pkgdir}${MINGW_PREFIX}"
}
